/**
 * @file TeXMFResources.h
 * @author Christian Schenk
 * @brief TeXMF resources
 *
 * @copyright Copyright © 1996-2022 Christian Schenk
 *
 * This file is part of the MiKTeX TeXMF Framework.
 *
 * The MiKTeX TeXMF Framework is licensed under GNU General Public License
 * version 2 or any later version.
 */
#pragma once

#include "config.h"

#include <miktex/Resources/ResourceRepository>

BEGIN_INTERNAL_NAMESPACE;

#include "/builddir/build/BUILD/miktex.25.4/redhat-linux-build/Libraries/MiKTeX/TeXAndFriends/locale/de/miktex-texmf.mo.h"
#include "/builddir/build/BUILD/miktex.25.4/redhat-linux-build/Libraries/MiKTeX/TeXAndFriends/locale/zh_CN/miktex-texmf.mo.h"


class TeXMFResources
  : public MiKTeX::Resources::ResourceRepository
{
protected:
    void Init() override
    {
        R_(":/de/LC_MESSAGES/miktex-texmf.mo", messages_de);
R_(":/zh_CN/LC_MESSAGES/miktex-texmf.mo", messages_zh_CN);

    }
private:
    template<std::size_t N> void R_(const char* resourceId, unsigned char const (&byteArray)[N])
    {
        AddResource(resourceId, { byteArray, sizeof(byteArray) });
    }
};

END_INTERNAL_NAMESPACE;
